libstdc++: std::ostream_iterator< _Tp, _CharT, _Traits > Class Template Reference

libstdc++

std::ostream_iterator< _Tp, _CharT, _Traits > Class Template Reference
Iterators

`#include <stream_iterator.h>`

Inheritance diagram for std::ostream_iterator< _Tp, _CharT, _Traits >:
[legend]

## Public Types
typedef output_iterator_tag | iterator_category
typedef void | pointer
typedef void | reference
typedef void | value_type
using | difference_type
typedef _CharT | char_type
typedef _Traits | traits_type
typedef basic_ostream< _CharT, _Traits > | ostream_type

## Public Member Functions
| ostream_iterator (const ostream_iterator &__obj) noexcept
| ostream_iterator (ostream_type &__s) noexcept
| ostream_iterator (ostream_type &__s, const _CharT *__c) noexcept
ostream_iterator & | operator* () noexcept
ostream_iterator & | operator++ () noexcept
ostream_iterator & | operator++ (int) noexcept
ostream_iterator & | operator= (const _Tp &__value)
ostream_iterator & | operator= (const ostream_iterator &)=default

## Detailed Description

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>
class std::ostream_iterator< _Tp, _CharT, _Traits >

Provides output iterator semantics for streams.

This class provides an iterator to write to an ostream. The type Tp is the only type written by this iterator and there must be an operator<<(Tp) defined.

Template Parameters

  _Tp | The type to write to the ostream.
  _CharT | The ostream char_type.
  _Traits | The ostream char_traits.

Definition at line 198 of file stream_iterator.h.

## Member Typedef Documentation

## ◆ char_type

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

typedef _CharT std::ostream_iterator< _Tp, _CharT, _Traits >::char_type

Public typedef.

Definition at line 207 of file stream_iterator.h.

## ◆ difference_type

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

using std::ostream_iterator< _Tp, _CharT, _Traits >::difference_type

Public typedef.

Definition at line 205 of file stream_iterator.h.

## ◆ iterator_category

typedef output_iterator_tag std::iterator< output_iterator_tag, void, void, void, void >::iterator_category
| inherited

One of the tag types.

Definition at line 137 of file stl_iterator_base_types.h.

## ◆ ostream_type

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

typedef basic_ostream<_CharT, _Traits> std::ostream_iterator< _Tp, _CharT, _Traits >::ostream_type

Public typedef.

Definition at line 209 of file stream_iterator.h.

## ◆ pointer

typedef void std::iterator< output_iterator_tag, void, void, void, void >::pointer
| inherited

This type represents a pointer-to-value_type.

Definition at line 143 of file stl_iterator_base_types.h.

## ◆ reference

typedef void std::iterator< output_iterator_tag, void, void, void, void >::reference
| inherited

This type represents a reference-to-value_type.

Definition at line 145 of file stl_iterator_base_types.h.

## ◆ traits_type

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

typedef _Traits std::ostream_iterator< _Tp, _CharT, _Traits >::traits_type

Public typedef.

Definition at line 208 of file stream_iterator.h.

## ◆ value_type

typedef void std::iterator< output_iterator_tag, void, void, void, void >::value_type
| inherited

The type "pointed to" by the iterator.

Definition at line 139 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

## ◆ ostream_iterator() [1/3]

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

std::ostream_iterator< _Tp, _CharT, _Traits >::ostream_iterator | ( | ostream_type & | __s | ) |
| inlinenoexcept

Construct from an ostream.

Definition at line 218 of file stream_iterator.h.

References std::__addressof().

Referenced by ostream_iterator().

## ◆ ostream_iterator() [2/3]

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

std::ostream_iterator< _Tp, _CharT, _Traits >::ostream_iterator | ( | ostream_type & | __s,
|  | const _CharT * | __c )
| inlinenoexcept

Construct from an ostream.

The delimiter string c is written to the stream after every Tp written to the stream. The delimiter is not copied, and thus must not be destroyed while this iterator is in use.

Parameters

  __s | Underlying ostream to write to.
  __c | CharT delimiter string to insert.

Definition at line 231 of file stream_iterator.h.

References std::__addressof().

## ◆ ostream_iterator() [3/3]

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

std::ostream_iterator< _Tp, _CharT, _Traits >::ostream_iterator | ( | const ostream_iterator< _Tp, _CharT, _Traits > & | __obj | ) |
| inlinenoexcept

Copy constructor.

Definition at line 235 of file stream_iterator.h.

References ostream_iterator().

## Member Function Documentation

## ◆ operator*()

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

ostream_iterator & std::ostream_iterator< _Tp, _CharT, _Traits >::operator* | ( |  | ) |
| inlinenodiscardnoexcept

Definition at line 258 of file stream_iterator.h.

## ◆ operator++() [1/2]

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

ostream_iterator & std::ostream_iterator< _Tp, _CharT, _Traits >::operator++ | ( |  | ) |
| inlinenoexcept

Definition at line 262 of file stream_iterator.h.

## ◆ operator++() [2/2]

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

ostream_iterator & std::ostream_iterator< _Tp, _CharT, _Traits >::operator++ | ( | int |  | ) |
| inlinenoexcept

Definition at line 266 of file stream_iterator.h.

## ◆ operator=()

template<typename _Tp, typename _CharT = char, typename _Traits = char_traits<_CharT>>

ostream_iterator & std::ostream_iterator< _Tp, _CharT, _Traits >::operator= | ( | const _Tp & | __value | ) |
| inline

Writes value to underlying ostream using operator<<. If constructed with delimiter string, writes delimiter to ostream.

Definition at line 245 of file stream_iterator.h.

The documentation for this class was generated from the following file:

- stream_iterator.h